import Button from "@/components/Low/Button";
import Input from "@/components/Low/Input";
import {Module} from "@/interfaces";
import useExamStore from "@/stores/examStore";
import {getExamById} from "@/utils/exams";
import {MODULE_ARRAY} from "@/utils/moduleUtils";
import {RadioGroup} from "@headlessui/react";
import clsx from "clsx";
import {capitalize} from "lodash";
import {useRouter} from "next/router";
import {FormEvent, useState} from "react";
import {toast} from "react-toastify";

export default function ExamLoader() {
	const [selectedModule, setSelectedModule] = useState<Module>();
	const [examId, setExamId] = useState<string>();
	const [isLoading, setIsLoading] = useState(false);

	const setExams = useExamStore((state) => state.setExams);
	const setSelectedModules = useExamStore((state) => state.setSelectedModules);

	const router = useRouter();

	const loadExam = async (e?: FormEvent) => {
		if (e) e.preventDefault();
		setIsLoading(true);

		if (selectedModule && examId) {
			const exam = await getExamById(selectedModule, examId.trim());
			if (!exam) {
				toast.error("Unknown Exam ID! Please make sure you selected the right module and entered the right exam ID", {
					toastId: "invalid-exam-id",
				});

				setIsLoading(false);
				return;
			}

			setExams([exam]);
			setSelectedModules([selectedModule]);

			router.push("/exercises");
		}

		setIsLoading(false);
	};

	return (
		<div className="flex flex-col gap-4 border p-4 border-mti-gray-platinum rounded-xl">
			<label className="font-normal text-base text-mti-gray-dim">Exam Loader</label>
			<form className="flex flex-col gap-4 w-full" onSubmit={loadExam}>
				<RadioGroup
					value={selectedModule}
					onChange={setSelectedModule}
					className="grid -md:grid-cols-2 md:grid-cols-1 xl:grid-cols-2 items-center gap-4 place-items-center">
					{MODULE_ARRAY.map((module) => (
						<RadioGroup.Option value={module} key={module}>
							{({checked}) => (
								<span
									className={clsx(
										"px-6 py-4 w-44 2xl:w-48 flex justify-center text-sm font-normal rounded-full border focus:outline-none cursor-pointer",
										"hover:bg-mti-purple-light hover:border-mti-purple-dark hover:text-white",
										"transition duration-300 ease-in-out",
										!checked ? "bg-white border-mti-gray-platinum" : "bg-mti-purple-light border-mti-purple-dark text-white",
									)}>
									{capitalize(module)}
								</span>
							)}
						</RadioGroup.Option>
					))}
				</RadioGroup>
				<Input type="text" name="examId" onChange={setExamId} placeholder="Exam ID" className="w-full" />
				<Button disabled={!selectedModule || !examId} isLoading={isLoading} className="w-full">
					Load Exam
				</Button>
			</form>
		</div>
	);
}
